import { EventEmitter } from '@angular/core';
import { FormControl } from '@angular/forms';
import { ControlValueAccessor } from '@angular/forms';
import { ConfigurationEditor } from '../data/configuration-editor';
export declare const CUSTOM_BITEDITOR_CONTROL_VALUE_ACCESSOR: any;
/**
* Clase que utiliza un custom componente para campo editor de HTML
* Utiliza la interfaz ControlValueAccessor
*    <bit-editor [(ngModel)]="object.descripcion" [ngModelOptions]="{standalone: true}" height="250">&nbsp;&nbsp;Descripció</bit-editor>
* Para utilizar, importar tambien js y css.
*
* https://www.primefaces.org/primeng/#/editor
* https://quilljs.com/docs/modules/toolbar/
*
**/
export declare class BitEditorComponent implements ControlValueAccessor {
    control: FormControl;
    nombre: any;
    tipo: String;
    configuration: ConfigurationEditor;
    placeholder: string;
    readOnly: boolean;
    height: number;
    hideLabel: boolean;
    private forceObligatorio;
    onChange: EventEmitter<string>;
    static globalConfiguration: ConfigurationEditor;
    private innerValue;
    private onTouchedCallback;
    private onChangeCallback;
    constructor();
    value: any;
    readonly value_lectura: string;
    changed(event: any): void;
    onFocus(): void;
    onInit(quill: any): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    readonly obligatorio: boolean;
    readonly configuracion: ConfigurationEditor;
}
