"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var general_utils_service_1 = require("../service/general-utils.service");
var BitLoadingComponent = (function () {
    function BitLoadingComponent(generalUtils) {
        var _this = this;
        //console.log("Constructor bitloading");
        this.inProgressCount = 0;
        this.subscription = generalUtils.observableLoading.subscribe(function (status) {
            if (status === "start")
                _this.inProgressCount++;
            if (status === "stop")
                _this.inProgressCount--;
            _this.loading = _this.inProgressCount > 0;
            console.log('loading', status, _this.inProgressCount);
        });
    }
    BitLoadingComponent.prototype.ngOnDestroy = function () {
        this.loading = false;
        if (this.subscription != null)
            this.subscription.unsubscribe();
    };
    BitLoadingComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'bit-loading',
                    template: "\n    <img class=\"icono-loading\" *ngIf=\"loading\" [src]=\"imageSource\" />\n    "
                },] },
    ];
    /** @nocollapse */
    BitLoadingComponent.ctorParameters = function () { return [
        { type: general_utils_service_1.GeneralUtils, },
    ]; };
    BitLoadingComponent.propDecorators = {
        "imageSource": [{ type: core_1.Input, args: ["source",] },],
    };
    return BitLoadingComponent;
}());
exports.BitLoadingComponent = BitLoadingComponent;
//# sourceMappingURL=bit-loading.component.js.map