"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var message_service_1 = require("../service/message.service");
var BitNotificationComponent = (function () {
    function BitNotificationComponent(messageService) {
        var _this = this;
        this.notificationMessages = [];
        this.errorMessages = [];
        //avisoService.initAvisosPedientes();  //hacer su propio componente que cargue los avisos
        //console.log("DialogComponent contructor(" + messageService  + ")");
        //Nos suscribimos a la espera de que envíen notificaciones
        this.subscriptionNotifications = messageService.observableNotifications.subscribe(function (message) {
            _this.showMessage(message);
        });
        //Nos suscribimos a la espera de que envíen notificaciones de error
        this.subscriptionNotificationsErrors = messageService.observableNotificationsErrors.subscribe(function (notificationError) {
            _this.showNotificationError(notificationError);
        });
    }
    BitNotificationComponent.prototype.showMessage = function (message) {
        this.notificationMessages = [];
        this.notificationMessages.push({ severity: message.severity, summary: message.title, detail: message.message });
    };
    BitNotificationComponent.prototype.showNotificationError = function (notificationError) {
        this.errorMessages = [];
        if (notificationError.multipleText) {
            for (var _i = 0, _a = notificationError.multipleText; _i < _a.length; _i++) {
                var error = _a[_i];
                this.errorMessages.push({ severity: 'error', summary: notificationError.textCA ? notificationError.textCA : notificationError.text, detail: error });
            }
        }
        else {
            this.errorMessages.push({ severity: 'error', summary: notificationError.textCA ? notificationError.textCA : notificationError.text, detail: notificationError.masInfo });
        }
    };
    BitNotificationComponent.prototype.ngOnDestroy = function () {
        // prevent memory leak when component destroyed
        this.notificationMessages = null;
        this.errorMessages = null;
        this.subscriptionNotifications.unsubscribe();
        this.subscriptionNotificationsErrors.unsubscribe();
    };
    BitNotificationComponent.MENSAJE_VOID = "No hi ha dades per mostrar";
    BitNotificationComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'bit-notification',
                    template: "\n  <p-growl [value]=\"notificationMessages\"></p-growl>\n  <p-messages [value]=\"errorMessages\" [closable]=\"true\"></p-messages>\n"
                },] },
    ];
    /** @nocollapse */
    BitNotificationComponent.ctorParameters = function () { return [
        { type: message_service_1.MessageService, },
    ]; };
    return BitNotificationComponent;
}());
exports.BitNotificationComponent = BitNotificationComponent;
//# sourceMappingURL=bit-notification.component.js.map