"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var general_utils_service_1 = require("./general-utils.service");
var CustomValidators = (function () {
    function CustomValidators() {
    }
    CustomValidators.getValidatorErrorMessage = function (code) {
        return this.config[code];
    };
    // método para unir validadores
    // método para unir validadores
    CustomValidators.compose = 
    // método para unir validadores
    function (validators) {
        return function (g) {
            // ejecutamos cada uno de los validadores y unimos sus resultados
            return validators
                .map(function (validator) { return validator(g); })
                .reduce(function (acc, result) {
                if (result === void 0) { result = {}; }
                return Object.assign(acc, result);
            }, {});
        };
    };
    CustomValidators.required = function (control) {
        if (!control.value) {
            return { 'required': true };
        }
        else {
            return null;
        }
    };
    // este validador en realidad no está haciendo nada porque bit-input, para fechas no válidas, sustituye
    // control.value por un null y el validador pasa siempre
    // este validador en realidad no está haciendo nada porque bit-input, para fechas no válidas, sustituye
    // control.value por un null y el validador pasa siempre
    CustomValidators.dataValidator = 
    // este validador en realidad no está haciendo nada porque bit-input, para fechas no válidas, sustituye
    // control.value por un null y el validador pasa siempre
    function (control) {
        // formato dd/MM/yyyy
        if (!control.value || control.value.match(/^(0[1-9]|1\d|2\d|3[01])\/(0[1-9]|1[0-2])\/(19|20)\d{2}$/)) {
            return null;
        }
        else {
            return { 'invalidDate': true };
        }
    };
    CustomValidators.timeValidator = function (control) {
        // formato hh:mm
        if (!control.value || (control.value && control.value.match(/^[0-9][0-9]:[0-9][0-9]$/))) {
            return null;
        }
        else {
            return { 'invalidTime': true };
        }
    };
    CustomValidators.emailValidator = function (control) {
        // RFC 2822 compliant regex
        if (!control.value || control.value.match(/\S+@([-\w]+\.)+\w+/g)) {
            return null;
        }
        else {
            return { 'invalidEmailAddress': true };
        }
    };
    CustomValidators.emailCSVValidator = function (control) {
        // RFC 2822 compliant regex
        if (!control.value || control.value.match(/^(( )*[\w\.]+@([-\w]+\.)+\w+( )*)(,( )*[\w\.]+@([-\w]+\.)+\w+( )*)*$/g)) {
            return null;
        }
        else {
            return { 'invalidEmailCSVAddress': true };
        }
    };
    CustomValidators.loginValidator = function (control) {
        if (!control.value || control.value.match(/^[a-z0-9_-]{3,15}/)) {
            return null;
        }
        else {
            return { 'invalidLogin': true };
        }
    };
    CustomValidators.etiquetaValidator = function (control) {
        if (!control.value || control.value.match(/^[a-zA-Z0-9_-]+/)) {
            return null;
        }
        else {
            return { 'invalidEtiqueta': true };
        }
    };
    CustomValidators.nombreValidator = function (control) {
        if (!control.value || /^([A-Za-z0-9_\.\,\'\"\(\)\;\:\-\/\@\?\%\?\¿\&\+\-\*\/\ \n\rºª'´’·ïü?`áéíóúÁÉÍÓÚàèìòùÀÈÌÒÙÄËÏÖÜäëïöüñÑçÇ¡!])+$/.test(control.value)) {
            return null;
        }
        else {
            return { 'invalidName': true };
        }
    };
    CustomValidators.codigoValidator = function (control) {
        if (!control.value || control.value.match(/^([0-9])+$/)) {
            return null;
        }
        else {
            return { 'invalidCodigo': true };
        }
    };
    CustomValidators.alfanumericoValidator = function (control) {
        if (!control.value || control.value.match(/^([A-Z0-9_\.\-ÑÇ])+$/)) {
            return null;
        }
        else {
            return { 'invalidAlfanumerico': true };
        }
    };
    CustomValidators.cantidadValidator = function (control) {
        // value is either empty, or a number without decimals
        if (control.value === '') {
            return null;
        }
        var num = Number(control.value);
        if (!isNaN(num) && (num % 1 == 0)) {
            return null;
        }
        return { 'invalidCantidad': true };
    };
    /* Valida numeros enteros (sin decimales) positivos (>=0) */
    /* Valida numeros enteros (sin decimales) positivos (>=0) */
    CustomValidators.enteroPositivoValidator = /* Valida numeros enteros (sin decimales) positivos (>=0) */
    function (control) {
        // value is either empty, or a number without decimals
        if (control.value === '') {
            return null;
        }
        var num = Number(control.value);
        if (!isNaN(num) && (num % 1 == 0) && num >= 0) {
            return null;
        }
        return { 'invalidEnteroPositivo': true };
    };
    /* Valida numeros enteros (con decimales) */
    /* Valida numeros enteros (con decimales) */
    CustomValidators.cantidadDecimalValidator = /* Valida numeros enteros (con decimales) */
    function (control) {
        // value is either empty, or a number (including decimals)
        if (control.value === '' || !isNaN(Number(control.value))) {
            return null;
        }
        else {
            return { 'invalidCantidadDecimal': true };
        }
    };
    /* Valida numeros enteros (con decimales) positivos (>=0) */
    /* Valida numeros enteros (con decimales) positivos (>=0) */
    CustomValidators.numeroPositivoValidator = /* Valida numeros enteros (con decimales) positivos (>=0) */
    function (control) {
        if (control.value === '' || (!isNaN(Number(control.value)) && Number(control.value) >= 0)) {
            return null;
        }
        else {
            return { 'invalidNumeroPositivo': true };
        }
    };
    /* Valida codigo postal (numero de 5 digitos) */
    /* Valida codigo postal (numero de 5 digitos) */
    CustomValidators.codigoPostalValidator = /* Valida codigo postal (numero de 5 digitos) */
    function (control) {
        if (!control.value || (control.value.match(/^([0-9])+$/) && control.value.length == 5)) {
            return null;
        }
        else {
            return { 'invalidCodigoPostal': true };
        }
    };
    /* Valida telefono (numero de 9 digitos) */
    /* Valida telefono (numero de 9 digitos) */
    CustomValidators.telefonoValidator = /* Valida telefono (numero de 9 digitos) */
    function (control) {
        if (!control.value || control.value.match(/^[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]$/)) {
            return null;
        }
        else {
            return { 'invalidTelefono': true };
        }
    };
    CustomValidators.buildLongitudValidator = function (lon) {
        var errorKey = "invalidLongitud-" + lon;
        this.config[errorKey] = "La dada no pot excedir els " + lon + " car\u00E0cters.";
        return function (control) {
            if (!control.value || control.value.length <= lon) {
                return null;
            }
            else {
                var ret = {};
                ret[errorKey] = true;
                return ret;
            }
        };
    };
    CustomValidators.buildCantidadMinValidator = function (min) {
        var errorKey = "invalidCantidadMin-" + min;
        this.config[errorKey] = "Format incorrecte. Nom\u00E9s s'accepten valors num\u00E8rics majors o iguals que " + min;
        return function (control) {
            var num = Number(control.value);
            if (control.value === '') {
                return null;
            }
            else if (isNaN(num) || num >= min) {
                // si no es numerico o el valor >= min, pasa la validacion
                return null;
            }
            else {
                var ret = {};
                ret[errorKey] = true;
                return ret;
            }
        };
    };
    CustomValidators.buildCantidadMaxValidator = function (max) {
        var errorKey = "invalidCantidadMax-" + max;
        this.config[errorKey] = "Format incorrecte. Nom\u00E9s s'accepten valors num\u00E8rics menors o iguals que " + max;
        return function (control) {
            var num = Number(control.value);
            if (control.value === '') {
                return null;
            }
            else if (isNaN(num) || num <= max) {
                // si no es numerico o el valor <= max, pasa la validacion
                return null;
            }
            else {
                var ret = {};
                ret[errorKey] = true;
                return ret;
            }
        };
    };
    CustomValidators.buildCantidadMinMaxValidator = function (min, max) {
        var errorKey = "invalidCantidadMinMax-" + min + "-" + max;
        this.config[errorKey] = "Format incorrecte. Nom\u00E9s s'accepten valors num\u00E8rics entre " + min + " i " + max;
        return function (control) {
            var num = Number(control.value);
            if (control.value === '') {
                return null;
            }
            else if (!isNaN(num) && num >= min && num <= max) {
                return null;
            }
            else {
                var ret = {};
                ret[errorKey] = true;
                return ret;
            }
        };
    };
    CustomValidators.porcentajeValidator = function (control) {
        // expected a numeric value between 0 and 100
        if (control.value === '') {
            return null;
        }
        else {
            var n = Number(control.value);
            if (!isNaN(n) && n >= 0 && n <= 100) {
                return null;
            }
            else {
                return { 'invalidPorcentaje': true };
            }
        }
    };
    CustomValidators.urlValidator = function (control) {
        var pattern = new RegExp('^(https?:\\/\\/)?' +
            '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.?)+[a-z]{2,}|' +
            '((\\d{1,3}\\.){3}\\d{1,3}))' +
            '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*' +
            '(\\?[;&a-z\\d%_.~+=-]*)?' +
            '(\\#[-a-z\\d_]*)?$', 'i'); // fragment locator
        if (!control.value || pattern.test(control.value)) {
            return null;
        }
        else {
            return { 'invalidUrl': true };
        }
    };
    CustomValidators.pathValidator = function (control) {
        var pattern = new RegExp('^((\\/)?[-a-z\\d%_.~+]*)*' +
            '(\\?[;&a-z\\d%_.~+=-]*)?' +
            '(\\#[-a-z\\d_]*)?$', 'i'); // fragment locator
        if (!control.value || pattern.test(control.value)) {
            return null;
        }
        else {
            return { 'invalidPath': true };
        }
    };
    /**
     * Retorna un string con todos los errores que contiene el formulario separados por saltos de línea.
     */
    /**
         * Retorna un string con todos los errores que contiene el formulario separados por saltos de línea.
         */
    CustomValidators.validateForm = /**
         * Retorna un string con todos los errores que contiene el formulario separados por saltos de línea.
         */
    function (form, prefix) {
        var mensajes = [];
        // errores a nivel de grupo
        for (var errorKey in form.errors) {
            var pr = prefix ? prefix + ": " : '';
            mensajes.push("" + pr + CustomValidators.config[errorKey]);
        }
        for (var controlKey in form.controls) {
            var control = form.controls[controlKey];
            if (!control.valid) {
                // no es válido, hay mensajes que recuperar
                var controlLabel = prefix ? prefix + " > " + controlKey : controlKey; // nombre apilado
                // detectamos si es un campo o un formulario anidado
                if (control instanceof forms_1.FormGroup) {
                    // es un formulario anidado, seguimos bajando recursivamente
                    mensajes = mensajes.concat(CustomValidators.validateForm(control, controlLabel));
                }
                else if (control instanceof forms_1.FormControl) {
                    // es un campo final, añadimos sus mensajes de error
                    for (var errorKey in control.errors) {
                        mensajes.push(controlLabel + ": " + CustomValidators.config[errorKey]);
                    }
                }
            }
        }
        return mensajes;
    };
    /**
     * Recibe un objeto con las propiedades {fieldTipo, fieldNumero} y devuelve un validador de formulario para documentos de identificación.
     * El error que puede generarse es del tipo 'invalidNumeroDocumentoTipoDocumento'.
     */
    /**
         * Recibe un objeto con las propiedades {fieldTipo, fieldNumero} y devuelve un validador de formulario para documentos de identificación.
         * El error que puede generarse es del tipo 'invalidNumeroDocumentoTipoDocumento'.
         */
    CustomValidators.buildNumeroDocumentoValidator = /**
         * Recibe un objeto con las propiedades {fieldTipo, fieldNumero} y devuelve un validador de formulario para documentos de identificación.
         * El error que puede generarse es del tipo 'invalidNumeroDocumentoTipoDocumento'.
         */
    function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.fieldTipo, fieldTipo = _c === void 0 ? 'documentoTipo' : _c, _d = _b.fieldNumero, fieldNumero = _d === void 0 ? 'documentoNumero' : _d;
        return function (g) {
            if (!g) {
                return null;
            }
            var documentoTipo = g.get(fieldTipo) && g.get(fieldTipo).value;
            var documentoNumero = g && g.get(fieldNumero) && g.get(fieldNumero).value;
            var invalid = false;
            if (documentoTipo && documentoNumero) {
                if (documentoTipo == 'DNI') {
                    invalid = !CustomValidators.isValidDNI(documentoNumero);
                }
                else if (documentoTipo == 'CIF') {
                    invalid = !CustomValidators.isValidCIF(documentoNumero);
                }
                else if (documentoTipo == 'NIF') {
                    //invalid = !documentoNumero.match(/^[0-9]{8}[a-z|A-Z]$/);
                    invalid = !CustomValidators.isValidNIF(documentoNumero);
                }
                else if (documentoTipo == 'NIE') {
                    invalid = !CustomValidators.isValidNIE(documentoNumero);
                }
            }
            return { 'invalidNumeroDocumentoTipoDocumento': invalid };
        };
    };
    CustomValidators.nifValidator = function (control) {
        var pattern = new RegExp(/^[0-9]{8}[a-z|A-Z]/); // TODO
        if (!control.value || pattern.test(control.value)) {
            return null;
        }
        else {
            return { 'invalidNIF': true };
        }
    };
    CustomValidators.cifValidator = function (control) {
        var pattern = new RegExp(/^[a-z|A-Z][0-9]{7}[a-z|A-Z|0-9]/); // TODO
        if (!control.value || pattern.test(control.value)) {
            return null;
        }
        else {
            return { 'invalidCIF': true };
        }
    };
    CustomValidators.anyoValidator = function (control) {
        var pattern = new RegExp(/^[0-9]{4}$/); // TODO
        if (!control.value || pattern.test(control.value)) {
            return null;
        }
        else {
            return { 'invalidAnyo': true };
        }
    };
    CustomValidators.tipoDatoTipoValidator = function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.fieldTramitacion, fieldTramitacion = _c === void 0 ? 'tramitacion' : _c, _d = _b.fieldInspeccion, fieldInspeccion = _d === void 0 ? 'inspeccion' : _d, _e = _b.fieldAutoevaluacion, fieldAutoevaluacion = _e === void 0 ? 'autoevaluacion' : _e;
        return function (g) {
            if (!g) {
                return null;
            }
            var tramitacion = g.get(fieldTramitacion) && g.get(fieldTramitacion).value;
            var inspeccion = g && g.get(fieldInspeccion) && g.get(fieldInspeccion).value;
            var autoevaluacion = g && g.get(fieldAutoevaluacion) && g.get(fieldAutoevaluacion).value;
            if (!tramitacion && !inspeccion && !autoevaluacion) {
                return { 'requiredTipoDatoTipoCheck': true };
            }
            return null;
        };
    };
    CustomValidators.isValidDNI = function (value) {
        return true; // ¿deberíamos validar algo? Con letra ya tenemos el NIF
    };
    // https://github.com/jquery-validation/jquery-validation/blob/master/src/additional/cifES.js
    // https://github.com/jquery-validation/jquery-validation/blob/master/src/additional/cifES.js
    CustomValidators.isValidCIF = 
    // https://github.com/jquery-validation/jquery-validation/blob/master/src/additional/cifES.js
    function (value) {
        var cifRegEx = new RegExp(/^([ABCDEFGHJKLMNPQRSUVW])(\d{7})([0-9A-J])$/gi);
        var letter = value.substring(0, 1), 
        // [ T ]
        number = value.substring(1, 8), 
        // [ P ][ P ][ N ][ N ][ N ][ N ][ N ]
        control = value.substring(8, 9), 
        // [ C ]
        all_sum = 0, even_sum = 0, odd_sum = 0, i, n, control_digit, control_letter;
        function isOdd(n) {
            return n % 2 === 0;
        }
        // Quick format test
        if (value.length !== 9 || !cifRegEx.test(value)) {
            return false;
        }
        for (i = 0; i < number.length; i++) {
            n = parseInt(number[i], 10);
            // Odd positions
            if (isOdd(i)) {
                // Odd positions are multiplied first.
                n *= 2;
                // If the multiplication is bigger than 10 we need to adjust
                odd_sum += n < 10 ? n : n - 9;
                // Even positions
                // Just sum them
            }
            else {
                even_sum += n;
            }
        }
        all_sum = even_sum + odd_sum;
        control_digit = (10 - Number((all_sum).toString().substr(-1))).toString();
        control_digit = parseInt(control_digit, 10) > 9 ? "0" : control_digit;
        control_letter = "JABCDEFGHI".substr(control_digit, 1).toString();
        // Control must be a digit
        if (letter.match(/[ABEH]/)) {
            return control === control_digit;
            // Control must be a letter
        }
        else if (letter.match(/[KPQS]/)) {
            return control === control_letter;
        }
        // Can be either
        return control === control_digit || control === control_letter;
    };
    // https://github.com/jquery-validation/jquery-validation/blob/master/src/additional/nifES.js
    // https://github.com/jquery-validation/jquery-validation/blob/master/src/additional/nifES.js
    CustomValidators.isValidNIF = 
    // https://github.com/jquery-validation/jquery-validation/blob/master/src/additional/nifES.js
    function (value) {
        value = value.toUpperCase();
        // Basic format test
        if (!value.match("((^[A-Z]{1}[0-9]{7}[A-Z0-9]{1}$|^[T]{1}[A-Z0-9]{8}$)|^[0-9]{8}[A-Z]{1}$)")) {
            return false;
        }
        // Test NIF
        if (/^[0-9]{8}[A-Z]{1}$/.test(value)) {
            return ("TRWAGMYFPDXBNJZSQVHLCKE".charAt(Number(value.substring(8, 0)) % 23) === value.charAt(8));
        }
        // Test specials NIF (starts with K, L or M)
        if (/^[KLM]{1}/.test(value)) {
            return (value[8] !== "TRWAGMYFPDXBNJZSQVHLCKE".charAt(Number(value.substring(8, 1)) % 23));
        }
        return false;
    };
    // https://github.com/jquery-validation/jquery-validation/blob/master/src/additional/nieES.js
    // https://github.com/jquery-validation/jquery-validation/blob/master/src/additional/nieES.js
    CustomValidators.isValidNIE = 
    // https://github.com/jquery-validation/jquery-validation/blob/master/src/additional/nieES.js
    function (value) {
        var nieRegEx = new RegExp(/^[MXYZ]{1}[0-9]{7,8}[TRWAGMYFPDXBNJZSQVHLCKET]{1}$/gi);
        var validChars = "TRWAGMYFPDXBNJZSQVHLCKET", letter = value.substr(value.length - 1).toUpperCase(), number;
        value = value.toString().toUpperCase();
        // Quick format test
        if (value.length > 10 || value.length < 9 || !nieRegEx.test(value)) {
            return false;
        }
        // X means same number
        // Y means number + 10000000
        // Z means number + 20000000
        value = value.replace(/^[X]/, "0")
            .replace(/^[Y]/, "1")
            .replace(/^[Z]/, "2");
        number = value.length === 9 ? value.substr(0, 8) : value.substr(0, 9);
        return validChars.charAt(parseInt(number, 10) % 23) === letter;
    };
    CustomValidators.rangoFechasValidator = function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.fieldFechaInicio, fieldFechaInicio = _c === void 0 ? 'fechaInicio' : _c, _d = _b.fieldFechaFin, fieldFechaFin = _d === void 0 ? 'fechaFin' : _d;
        return function (g) {
            if (!g) {
                return null;
            }
            var fechaInicio = g.get(fieldFechaInicio) && g.get(fieldFechaInicio).value;
            var fechaFin = g && g.get(fieldFechaFin) && g.get(fieldFechaFin).value;
            if (fechaInicio && fechaFin) {
                var inicio = general_utils_service_1.GeneralUtils.stringShortToDate(fechaInicio);
                var fin = general_utils_service_1.GeneralUtils.stringShortToDate(fechaFin);
                if (inicio > fin) {
                    return { 'invalidRangoFechaFinPosteriorInicio': true, 'requiredTipoDatoTipoCheck': true };
                }
            }
            return null;
        };
    };
    CustomValidators.rangoHorasValidator = function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.fieldHoraInicio, fieldHoraInicio = _c === void 0 ? 'horaInicio' : _c, _d = _b.fieldHoraFin, fieldHoraFin = _d === void 0 ? 'horaFin' : _d;
        return function (g) {
            if (!g) {
                return null;
            }
            var inicio = g.get(fieldHoraInicio) && g.get(fieldHoraInicio).value && general_utils_service_1.GeneralUtils.stringToTime(g.get(fieldHoraInicio).value);
            var fin = g && g.get(fieldHoraFin) && g.get(fieldHoraFin).value && general_utils_service_1.GeneralUtils.stringToTime(g.get(fieldHoraFin).value);
            if (inicio && fin && inicio >= fin) {
                return { 'invalidRangoHoraFinPosteriorInicio': true };
            }
            return null;
        };
    };
    CustomValidators.dateTimeNotAfterCurrentDateValidator = function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.fieldfecha, fieldfecha = _c === void 0 ? 'fecha' : _c, _d = _b.fieldHora, fieldHora = _d === void 0 ? 'hora' : _d;
        return function (g) {
            if (!g) {
                return null;
            }
            var campoFecha = g.get(fieldfecha);
            var campoHora = g.get(fieldHora);
            if (campoFecha && campoFecha.value && campoFecha.value.match(/^(0[1-9]|1\d|2\d|3[01])\/(0[1-9]|1[0-2])\/(19|20)\d{2}$/)) {
                var date = general_utils_service_1.GeneralUtils.getStringAsDate(campoFecha.value);
                if (campoHora && campoHora.value && campoHora.value.match(/^[0-9][0-9]:[0-9][0-9]$/)) {
                    date.setHours(campoHora.value.split(":")[0]);
                    date.setMinutes(campoHora.value.split(":")[1]);
                }
                if (date < new Date()) {
                    return { 'invalidDateTimeNotAfterCurrentDate': true };
                }
            }
            return null;
        };
    };
    CustomValidators.config = {
        'required': 'Camp obligatori',
        'invalidDate': 'Data incorrecta',
        'invalidEmailAddress': 'Adreça electrònica incorrecta',
        'invalidEmailCSVAddress': 'Format adreça electrònica incorrecta',
        'invalidLogin': 'Login incorrecte',
        'invalidEtiqueta': 'Etiqueta incorrecta, només s\'accepten valors alfanumèrics i "_"',
        'invalidName': 'Valor incorrecte',
        'invalidCodigo': 'Format de codi incorrecte',
        'invalidAlfanumerico': 'Format alfanumèric incorrecte',
        'invalidCantidad': 'Format incorrecte, només s\'accepten valors numèrics (sense decimals)',
        'invalidEnteroPositivo': 'Introdueixi numèrics (sense decimals) positius',
        'invalidCantidadDecimal': 'Format incorrecte, només s\'accepten valors numèrics (amb decimals)',
        'invalidNumeroPositivo': 'Introdueixi un valor numèric (amb decimals) positius',
        'invalidCodigoPostal': 'Introdueixi 5 digits',
        'invalidTelefono': 'Introdueixi 9 valors numèrics',
        'invalidPorcentaje': 'Porcentatge incorrecte, només s\'accepten valors numèrics entre 0 i 100',
        'invalidUrl': 'Adreça web incorrecta',
        'invalidPath': 'Ruta incorrecte',
        'invalidNIF': 'NIF incorrecte',
        'invalidCIF': 'CIF incorrecte',
        'invalidAnyo': 'Format incorrecte, només s\'accepten anys amb quatre dígits',
        'maxlength': 'Camp massa llarg',
        'invalidNumeroDocumentoTipoDocumento': 'Format del número de document incorrecte',
        'direccionIncompleta': 'Municipi i codi postal de l\'adreça obligatoris',
        'requiredExtraData': 'Altres dades són obligatòries',
        'requiredProtocoloId': 'Heu d\'especificar un protocol d\'inspecció',
        'requiredTipoDatoTipoCheck': 'Heu d\'especificar si el tipus de dada aplica a tramitacions, inspeccions i/o autoevaluacions',
        'invalidRangoFechaFinPosteriorInicio': 'La data de fi ha de ser posterior a la data d\'inici',
        'invalidRangoHoraFinPosteriorInicio': 'L\'hora de fi ha de ser posterior a l\'hora d\'inici',
        'invalidDateTimeNotAfterCurrentDate': 'La data i hora ha de ser posterior a la data actual',
        'agendaInvalidRangoFechaFinPosteriorInicio': 'La data de fi ha de ser posterior a la data d\'inici',
        'agendaInvalidRangoFechaCampanya': 'Les dates d\'inici i de fi han de ser dins el període de la campanya',
        'agendaInvalidSeleccionServicios': 'Heu de seleccionar almenys un servei',
        'agendaInvalidPlazasServicioMultiple': 'Heu d\'indicar el número de places del servei múltiple',
        'agendaInvalidSeleccionHorario': 'És necessari omplir almenys una hora d`inici i una hora de fi de qualsevol dia per guardar l\'agenda'
    };
    CustomValidators.CustomValidatorsMap = {
        "codigoNumerico": CustomValidators.codigoValidator,
        "codigoAlfanumerico": CustomValidators.alfanumericoValidator,
        "nombre": CustomValidators.nombreValidator,
        "numero": CustomValidators.cantidadDecimalValidator,
        "entero": CustomValidators.cantidadValidator,
        "numeroPositivo": CustomValidators.numeroPositivoValidator,
        "enteroPositivo": CustomValidators.enteroPositivoValidator,
        "cif": CustomValidators.cifValidator,
        "nif": CustomValidators.nifValidator,
        "cp": CustomValidators.codigoPostalValidator,
        "telefono": CustomValidators.telefonoValidator,
        "email": CustomValidators.emailValidator,
        "anyo": CustomValidators.anyoValidator
    };
    CustomValidators.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    CustomValidators.ctorParameters = function () { return []; };
    return CustomValidators;
}());
exports.CustomValidators = CustomValidators;
//# sourceMappingURL=custom-validators.service.js.map