import { HttpClient, HttpErrorResponse } from '@angular/common/http';
import { Observable } from 'rxjs/Observable';
import { Error as CustomError } from '../data/error';
import { MessageService } from './message.service';
import { GeneralUtils } from './general-utils.service';
export declare class HttpUtilsService {
    http: HttpClient;
    messageService: MessageService;
    generalUtils: GeneralUtils;
    private apiUrl;
    private contextPath;
    static CONTEXT_PATH: string;
    constructor(http: HttpClient, messageService: MessageService, generalUtils: GeneralUtils, apiUrl: string, contextPath: string);
    private handleError(error);
    static getCustomError(error: HttpErrorResponse): CustomError;
    static reloadPage(): void;
    getHttpPost<T>(url: any, hqlRequest: any, emptyResponse?: boolean): Observable<T>;
    getHttpPut<T>(url: any, hqlRequest: any): Observable<T>;
    getHttpDelete(url: any): Observable<any>;
    getHttpGet<T>(url: any): Observable<T>;
}
export declare var httpUtilsServiceInjectables: Array<any>;
